%%% EUZENAT & STUCKENSCHMIDT'S KNOWLEDGE TRANSFORMATIONS
%%% (in terms of the basic life-cycle ontology)

:- load_files(['basic_life.pl']).

%%% ------------------------------------------------------------------
%%% language inclusion

language_inclusion(C1,C2) :-
	language_strengthening(morph(_,_,P),C1,C2),
	type_inclusive(P).
language_inclusion(C1,C3) :-
	language_inclusion(C1,C2),
	language_inclusion(C2,C3).

%%% ------------------------------------------------------------------
%%% interpretation preserving transformation

interpretation_preserving_transformation(C1,C2) :-
	language_strengthening(morph(_,_,P),C1,C2),
	type_injective(P).
interpretation_preserving_transformation(C1,C3) :-
	interpretation_preserving_transformation(C1,C2),
	interpretation_preserving_transformation(C2,C3).

%%% ------------------------------------------------------------------
%%% expressibility preserving transformation

expressibility_preserving_transformation(C1,C2) :-
	language_strengthening(morph(_,_,P),C1,C2),
	token_surjective(P).
expressibility_preserving_transformation(C1,C3) :-
	expressibility_preserving_transformation(C1,C2),
	expressibility_preserving_transformation(C2,C3).

%%% ------------------------------------------------------------------
%%% epimorphic transformation

epimorphic_transformation(C1,C2) :-
	language_strengthening(_,C1,C2).
epimorphic_transformation(C1,C3) :-
	epimorphic_transformation(C1,C2),
	epimorphic_transformation(C2,C3).

