:- op(800, xfx, [=>]).

:- use_module(library(lists)).
:- use_module(artofprolog).
:- use_module(misc).

getLifeCycleSpec(lifecycle(_,Spec), Spec).

getEmptyLifeCycle(Name, LifeCycle) :-
	ontologyName(Ontology),
	Ant =.. [Name,X,Y],
	LC = lifecycle(Ontology,
		       Ant => exists([],['NT'(knowledge_transformation(X,Y))])),
	freeze_term(LC, LifeCycle).

% 'NT'(...) means it's a non-terminal and will be displayed as a button


getNameArity(Ant => _, Name, Arity) :-
	Ant =.. [Name|Args],
	length(Args, Arity).

skolemize(Ant => exists(Vars,Succ), Ant => SkSucc) :-
	skolemize(Vars, Succ, SkSucc).

skolemize([], Succ, Succ).
skolemize([V|Vars], Succ1, Succ2) :-
	makeConstant(V, C),
	ground_subst(V, C, Succ1, Succ3),
	skolemize(Vars, Succ3, Succ2).

makeConstant('$VAR'(N), C) :-
	atom_number(Num, N),
	atom_concat('skolem_', Num, C).


